Index: /trunk/src/org/expeditee/io/DefaultFrameReader.java
===================================================================
--- /trunk/src/org/expeditee/io/DefaultFrameReader.java	(revision 1412)
+++ /trunk/src/org/expeditee/io/DefaultFrameReader.java	(revision 1413)
@@ -99,72 +99,72 @@
 
 			// Note: As of 26/11/18 there are no unused letter item tags.  Use other characters.
-			_ItemTags.put('S', Item.class.getMethod("setID", pInt));
-			_ItemTags.put('s', Item.class.getMethod("setDateCreated", pString));
-			_ItemTags.put('d', Item.class.getMethod("setColor", pColor));
-			_ItemTags.put('G', Item.class.getMethod("setBackgroundColor",
+			_ItemTags.put(DefaultFrameWriter.TYPE_AND_ID, Item.class.getMethod("setID", pInt));
+			_ItemTags.put(DefaultFrameWriter.DATE_CREATED, Item.class.getMethod("setDateCreated", pString));
+			_ItemTags.put(DefaultFrameWriter.COLOR, Item.class.getMethod("setColor", pColor));
+			_ItemTags.put(DefaultFrameWriter.BACKGROUND_COLOR, Item.class.getMethod("setBackgroundColor",
 					pColor));
-			_ItemTags.put('K', Item.class.getMethod("setBorderColor",
+			_ItemTags.put(DefaultFrameWriter.BORDER_COLOR, Item.class.getMethod("setBorderColor",
 					pColor));
 
-			_ItemTags.put('R', Item.class.getMethod("setAnchorLeft", pIntO));
-			_ItemTags.put('H', Item.class.getMethod("setAnchorRight", pIntO));
-			_ItemTags.put('N', Item.class.getMethod("setAnchorTop", pIntO));
-			_ItemTags.put('I', Item.class.getMethod("setAnchorBottom", pIntO));
-
-			_ItemTags.put('P', Item.class.getMethod("setPosition", pPoint));
-			_ItemTags.put('F', Item.class.getMethod("setLink", pString));
-			_ItemTags.put('J', Item.class.getMethod("setFormula", pString));
-			
-			_ItemTags.put('X', Item.class.getMethod("setActions", pList));
-			_ItemTags.put('x', Item.class.getMethod("setActionMark", pBool));
-			_ItemTags.put('U', Item.class.getMethod("setActionCursorEnter",
-					pList));
-			_ItemTags.put('V', Item.class.getMethod("setActionCursorLeave",
-					pList));
-			_ItemTags.put('W', Item.class.getMethod("setActionEnterFrame",
-					pList));
-			_ItemTags.put('Y', Item.class.getMethod("setActionLeaveFrame",
-					pList));
-			_ItemTags.put('D', Item.class.getMethod("addToData", pString));
-			_ItemTags.put('u', Item.class.getMethod("setHighlight", pBool));
-			_ItemTags.put('e', Item.class.getMethod("setFillColor", pColor));
-			_ItemTags.put('E', Item.class.getMethod("setGradientColor", pColor));
-			_ItemTags.put('Q', Item.class.getMethod("setGradientAngle", pDouble));
-			
-			_ItemTags.put('i', Item.class.getMethod("setFillPattern", pString));
-			_ItemTags.put('o', Item.class.getMethod("setOwner", pString));
-			_ItemTags.put('n', Item.class.getMethod("setLinkMark", pBool));
+			_ItemTags.put(DefaultFrameWriter.ANCHOR_LEFT, Item.class.getMethod("setAnchorLeft", pIntO));
+			_ItemTags.put(DefaultFrameWriter.ANCHOR_RIGHT, Item.class.getMethod("setAnchorRight", pIntO));
+			_ItemTags.put(DefaultFrameWriter.ANCHOR_TOP, Item.class.getMethod("setAnchorTop", pIntO));
+			_ItemTags.put(DefaultFrameWriter.ANCHOR_BOTTOM, Item.class.getMethod("setAnchorBottom", pIntO));
+
+			_ItemTags.put(DefaultFrameWriter.POSITION, Item.class.getMethod("setPosition", pPoint));
+			_ItemTags.put(DefaultFrameWriter.LINK, Item.class.getMethod("setLink", pString));
+			_ItemTags.put(DefaultFrameWriter.FORMULA, Item.class.getMethod("setFormula", pString));
+			
+			_ItemTags.put(DefaultFrameWriter.ACTION, Item.class.getMethod("setActions", pList));
+			_ItemTags.put(DefaultFrameWriter.ACTION_MARK, Item.class.getMethod("setActionMark", pBool));
+			_ItemTags.put(DefaultFrameWriter.ACTION_CURSOR_ENTER, Item.class.getMethod("setActionCursorEnter",
+					pList));
+			_ItemTags.put(DefaultFrameWriter.ACTION_CURSOR_LEAVE, Item.class.getMethod("setActionCursorLeave",
+					pList));
+			_ItemTags.put(DefaultFrameWriter.ACTION_ENTER_FRAME, Item.class.getMethod("setActionEnterFrame",
+					pList));
+			_ItemTags.put(DefaultFrameWriter.ACTION_LEAVE_FRAME, Item.class.getMethod("setActionLeaveFrame",
+					pList));
+			_ItemTags.put(DefaultFrameWriter.DATA, Item.class.getMethod("addToData", pString));
+			_ItemTags.put(DefaultFrameWriter.HIGHLIGHT, Item.class.getMethod("setHighlight", pBool));
+			_ItemTags.put(DefaultFrameWriter.FILL_COLOR, Item.class.getMethod("setFillColor", pColor));
+			_ItemTags.put(DefaultFrameWriter.GRADIENT_COLOR, Item.class.getMethod("setGradientColor", pColor));
+			_ItemTags.put(DefaultFrameWriter.GRADIENT_ANGLE, Item.class.getMethod("setGradientAngle", pDouble));
+			
+			_ItemTags.put(DefaultFrameWriter.FILL_PATTERN, Item.class.getMethod("setFillPattern", pString));
+			_ItemTags.put(DefaultFrameWriter.OWNER, Item.class.getMethod("setOwner", pString));
+			_ItemTags.put(DefaultFrameWriter.LINK_MARK, Item.class.getMethod("setLinkMark", pBool));
 			_ItemTags
-					.put('q', Item.class.getMethod("setLinkFrameset", pString));
+					.put(DefaultFrameWriter.LINK_FRAMESET, Item.class.getMethod("setLinkFrameset", pString));
 			_ItemTags
-					.put('y', Item.class.getMethod("setLinkTemplate", pString));
-			_ItemTags.put('g', Item.class.getMethod("setLinePattern", pIntArray));
-
-			_ItemTags.put('j', Item.class.getMethod("setArrow", pArrow));
-
-			_ItemTags.put('v', Dot.class.getMethod("setDotType", pDotType));
-			_ItemTags.put('z', Dot.class.getMethod("setFilled", pBool));
-			
-			_ItemTags.put('f', Text.class.getMethod("setFont", pFont));
-			_ItemTags.put('t', Text.class.getMethod("setSpacing", pFloat));
-			_ItemTags.put('T', Text.class.getMethod("appendLine", pString));
-			_ItemTags.put('a', Text.class.getMethod("setWordSpacing", pInt));
-			_ItemTags.put('b', Text.class.getMethod("setLetterSpacing", pFloat));
-			_ItemTags.put('m', Text.class.getMethod("setInitialSpacing", pFloat));
-			_ItemTags.put('w', Text.class.getMethod("setWidth", pIntO));
-			_ItemTags.put('M', Text.class.getMethod("setMinWidth", pIntO));
-			_ItemTags.put('k', Text.class.getMethod("setJustification", pJustification));
-			_ItemTags.put('r', Text.class.getMethod("setAutoWrap", pBool));
-
-			_ItemTags.put('h', Item.class.getMethod("setThickness", pFloat));
-			_ItemTags.put('l', Item.class.getMethod("setLineIDs", pString));
-			_ItemTags.put('c', Item.class.getMethod("setConstraintIDs", pString));
-			
-			_ItemTags.put('A', Item.class.getMethod("setTooltip", pString));
-			_ItemTags.put('B', Item.class.getMethod("setLinkHistory", pBool));
-			
-			_ItemTags.put('p', Item.class.getMethod("setPermission", pPermission));
-			
-			_ItemTags.put('O', Text.class.getMethod("setMask", pIntO));
+					.put(DefaultFrameWriter.LINK_TEMPLATE, Item.class.getMethod("setLinkTemplate", pString));
+			_ItemTags.put(DefaultFrameWriter.LINE_PATTERN, Item.class.getMethod("setLinePattern", pIntArray));
+
+			_ItemTags.put(DefaultFrameWriter.ARROW, Item.class.getMethod("setArrow", pArrow));
+
+			_ItemTags.put(DefaultFrameWriter.DOT_TYPE, Dot.class.getMethod("setDotType", pDotType));
+			_ItemTags.put(DefaultFrameWriter.FILLED, Dot.class.getMethod("setFilled", pBool));
+			
+			_ItemTags.put(DefaultFrameWriter.FONT, Text.class.getMethod("setFont", pFont));
+			_ItemTags.put(DefaultFrameWriter.SPACING, Text.class.getMethod("setSpacing", pFloat));
+			_ItemTags.put(DefaultFrameWriter.TEXT, Text.class.getMethod("appendLine", pString));
+			_ItemTags.put(DefaultFrameWriter.WORD_SPACING, Text.class.getMethod("setWordSpacing", pInt));
+			_ItemTags.put(DefaultFrameWriter.LETTER_SPACING, Text.class.getMethod("setLetterSpacing", pFloat));
+			_ItemTags.put(DefaultFrameWriter.INITIAL_SPACING, Text.class.getMethod("setInitialSpacing", pFloat));
+			_ItemTags.put(DefaultFrameWriter.WIDTH_TO_SAVE, Text.class.getMethod("setWidth", pIntO));
+			_ItemTags.put(DefaultFrameWriter.MIN_WIDTH_TO_SAVE, Text.class.getMethod("setMinWidth", pIntO));
+			_ItemTags.put(DefaultFrameWriter.JUSTIFICATION, Text.class.getMethod("setJustification", pJustification));
+			_ItemTags.put(DefaultFrameWriter.AUTO_WRAP_TO_SAVE, Text.class.getMethod("setAutoWrap", pBool));
+
+			_ItemTags.put(DefaultFrameWriter.THICKNESS, Item.class.getMethod("setThickness", pFloat));
+			_ItemTags.put(DefaultFrameWriter.LINE_IDS, Item.class.getMethod("setLineIDs", pString));
+			_ItemTags.put(DefaultFrameWriter.CONSTRAINT_IDS, Item.class.getMethod("setConstraintIDs", pString));
+			
+			_ItemTags.put(DefaultFrameWriter.TOOLTIP, Item.class.getMethod("setTooltip", pString));
+			_ItemTags.put(DefaultFrameWriter.LINK_HISTORY, Item.class.getMethod("setLinkHistory", pBool));
+			
+			_ItemTags.put(DefaultFrameWriter.PERMISSION, Item.class.getMethod("setPermission", pPermission));
+			
+			_ItemTags.put(DefaultFrameWriter.MASK, Text.class.getMethod("setMask", pIntO));
 			
 			// Lines and constraints are created differently
@@ -172,18 +172,18 @@
 			_ItemTags.put('C', Constraint.class.getMethod("getID", (Class[]) null));
 			
-			_ItemTags.put('[', Item.class.getMethod("setMagnetizedItemLeft", pInt));
+			_ItemTags.put(DefaultFrameWriter.MAGNETIZED_ITEM_LEFT, Item.class.getMethod("setMagnetizedItemLeft", pInt));
 			_DelayedItemTags.add('[');
-			_ItemTags.put(']', Item.class.getMethod("setMagnetizedItemRight", pInt));
+			_ItemTags.put(DefaultFrameWriter.MAGNETIZED_ITEM_RIGHT, Item.class.getMethod("setMagnetizedItemRight", pInt));
 			_DelayedItemTags.add(']');
-			_ItemTags.put('^', Item.class.getMethod("setMagnetizedItemTop", pInt));
+			_ItemTags.put(DefaultFrameWriter.MAGNETIZED_ITEM_TOP, Item.class.getMethod("setMagnetizedItemTop", pInt));
 			_DelayedItemTags.add('^');
-			_ItemTags.put('/', Item.class.getMethod("setMagnetizedItemBottom", pInt));
+			_ItemTags.put(DefaultFrameWriter.MAGNETIZED_ITEM_BOTTOM, Item.class.getMethod("setMagnetizedItemBottom", pInt));
 			_DelayedItemTags.add('/');
 			
-			_ItemTagsExt.put("_el", Item.class.getMethod("setEncryptionLabelOnLoad", pString));
-			
-			_ItemTagsExt.put("_ph", Text.class.getMethod("setPlaceholder", pString));
-			_ItemTagsExt.put("_sl", Text.class.getMethod("setSingleLineOnly", pBool));
-			_ItemTagsExt.put("_ti", Text.class.getMethod("setTabIndex", pInt));
+			_ItemTagsExt.put(DefaultFrameWriter.ENCRYPTION_LABEL_STR, Item.class.getMethod("setEncryptionLabelOnLoad", pString));
+			
+			_ItemTagsExt.put(DefaultFrameWriter.PLACEHOLDER_STR, Text.class.getMethod("setPlaceholder", pString));
+			_ItemTagsExt.put(DefaultFrameWriter.SINGLE_LINE_ONLY_STR, Text.class.getMethod("setSingleLineOnly", pBool));
+			_ItemTagsExt.put(DefaultFrameWriter.TAB_INDEX_STR, Text.class.getMethod("setTabIndex", pInt));
 		} catch (Exception e) {
 			e.printStackTrace();
Index: /trunk/src/org/expeditee/io/DefaultFrameWriter.java
===================================================================
--- /trunk/src/org/expeditee/io/DefaultFrameWriter.java	(revision 1412)
+++ /trunk/src/org/expeditee/io/DefaultFrameWriter.java	(revision 1413)
@@ -41,62 +41,115 @@
 public abstract class DefaultFrameWriter extends ItemWriter implements
 		FrameWriter {
-
-	public static final String TAB_INDEX = "_ti";
-	public static final String SINGLE_LINE_ONLY = "_sl";
-	public static final String PLACEHOLDER = "_ph";
-	public static final String ENCRYPTION_LABEL = "_el";
-	public static final char MAGNETIZED_ITEM_BOTTOM = '/';
-	public static final char MAGNETIZED_ITEM_TOP = '^';
-	public static final char MAGNETIZED_ITEM_RIGHT = ']';
-	public static final char MAGNETIZED_ITEM_LEFT = '[';
-	public static final char PERMISSION = 'p';
-	public static final char LINK_HISTORY = 'B';
-	public static final char TOOLTIP = 'A';
-	public static final char CONSTRAINT_IDS = 'c';
-	public static final char LINE_IDS = 'l';
-	public static final char THICKNESS = 'h';
-	public static final char AUTO_WRAP_TO_SAVE = 'r';
-	public static final char JUSTIFICATION = 'k';
-	public static final char MIN_WIDTH_TO_SAVE = 'M';
-	public static final char WIDTH_TO_SAVE = 'w';
-	public static final char INITIAL_SPACING = 'm';
-	public static final char LETTER_SPACING = 'b';
-	public static final char WORD_SPACING = 'a';
-	public static final char FORMULA = 'J';
-	public static final char MASK = 'O';
-	public static final char SPACING = 't';
-	public static final char FONT = 'f';
-	public static final char FILLED = 'z';
-	public static final char DOT_TYPE = 'v';
-	public static final char ARROW = 'j';
-	public static final char LINE_PATTERN = 'g';
-	public static final char LINK_TEMPLATE = 'y';
-	public static final char LINK_FRAMESET = 'q';
-	public static final char LINK_MARK = 'n';
-	public static final char OWNER = 'o';
-	public static final char FILL_PATTERN = 'i';
-	public static final char ANCHOR_BOTTOM = 'I';
-	public static final char ANCHOR_TOP = 'N';
-	public static final char ANCHOR_RIGHT = 'H';
-	public static final char ANCHOR_LEFT = 'R';
-	public static final char GRADIENT_ANGLE = 'Q';
-	public static final char GRADIENT_COLOR = 'E';
-	public static final char FILL_COLOR = 'e';
-	public static final char HIGHLIGHT = 'u';
-	public static final char DATA = 'D';
-	public static final char ACTION_LEAVE_FRAME = 'Y';
-	public static final char ACTION_ENTER_FRAME = 'W';
-	public static final char ACTION_CURSOR_LEAVE = 'V';
-	public static final char ACTION_CURSOR_ENTER = 'U';
-	public static final char ACTION_MARK = 'x';
-	public static final char ACTION = 'X';
-	public static final char LINK = 'F';
-	public static final char TEXT = 'T';
-	public static final char POSITION = 'P';
-	public static final char BORDER_COLOR = 'K';
-	public static final char BACKGROUND_COLOR = 'G';
-	public static final char COLOR = 'd';
-	public static final char DATE_CREATED = 's';
-	public static final char TYPE_AND_ID = 'S';
+	protected static final char MAGNETIZED_ITEM_BOTTOM = '/';
+	protected static final char MAGNETIZED_ITEM_TOP = '^';
+	protected static final char MAGNETIZED_ITEM_RIGHT = ']';
+	protected static final char MAGNETIZED_ITEM_LEFT = '[';
+	protected static final char PERMISSION = 'p';
+	protected static final char LINK_HISTORY = 'B';
+	protected static final char TOOLTIP = 'A';
+	protected static final char CONSTRAINT_IDS = 'c';
+	protected static final char LINE_IDS = 'l';
+	protected static final char THICKNESS = 'h';
+	protected static final char AUTO_WRAP_TO_SAVE = 'r';
+	protected static final char JUSTIFICATION = 'k';
+	protected static final char MIN_WIDTH_TO_SAVE = 'M';
+	protected static final char WIDTH_TO_SAVE = 'w';
+	protected static final char INITIAL_SPACING = 'm';
+	protected static final char LETTER_SPACING = 'b';
+	protected static final char WORD_SPACING = 'a';
+	protected static final char FORMULA = 'J';
+	protected static final char MASK = 'O';
+	protected static final char SPACING = 't';
+	protected static final char FONT = 'f';
+	protected static final char FILLED = 'z';
+	protected static final char DOT_TYPE = 'v';
+	protected static final char ARROW = 'j';
+	protected static final char LINE_PATTERN = 'g';
+	protected static final char LINK_TEMPLATE = 'y';
+	protected static final char LINK_FRAMESET = 'q';
+	protected static final char LINK_MARK = 'n';
+	protected static final char OWNER = 'o';
+	protected static final char FILL_PATTERN = 'i';
+	protected static final char ANCHOR_BOTTOM = 'I';
+	protected static final char ANCHOR_TOP = 'N';
+	protected static final char ANCHOR_RIGHT = 'H';
+	protected static final char ANCHOR_LEFT = 'R';
+	protected static final char GRADIENT_ANGLE = 'Q';
+	protected static final char GRADIENT_COLOR = 'E';
+	protected static final char FILL_COLOR = 'e';
+	protected static final char HIGHLIGHT = 'u';
+	protected static final char DATA = 'D';
+	protected static final char ACTION_LEAVE_FRAME = 'Y';
+	protected static final char ACTION_ENTER_FRAME = 'W';
+	protected static final char ACTION_CURSOR_LEAVE = 'V';
+	protected static final char ACTION_CURSOR_ENTER = 'U';
+	protected static final char ACTION_MARK = 'x';
+	protected static final char ACTION = 'X';
+	protected static final char LINK = 'F';
+	protected static final char TEXT = 'T';
+	protected static final char POSITION = 'P';
+	protected static final char BORDER_COLOR = 'K';
+	protected static final char BACKGROUND_COLOR = 'G';
+	protected static final char COLOR = 'd';
+	protected static final char DATE_CREATED = 's';
+	protected static final char TYPE_AND_ID = 'S';
+	
+	public static final String TAB_INDEX_STR = "_ti";
+	public static final String SINGLE_LINE_ONLY_STR = "_sl";
+	public static final String PLACEHOLDER_STR = "_ph";
+	public static final String ENCRYPTION_LABEL_STR = "_el";
+	public static final String MAGNETIZED_ITEM_BOTTOM_STR = MAGNETIZED_ITEM_BOTTOM + "";
+	public static final String MAGNETIZED_ITEM_TOP_STR = MAGNETIZED_ITEM_TOP + "";
+	public static final String MAGNETIZED_ITEM_RIGHT_STR = MAGNETIZED_ITEM_RIGHT + "";
+	public static final String MAGNETIZED_ITEM_LEFT_STR = MAGNETIZED_ITEM_LEFT + "";
+	public static final String PERMISSION_STR = PERMISSION + "";
+	public static final String LINK_HISTORY_STR = LINK_HISTORY + "";
+	public static final String TOOLTIP_STR = TOOLTIP + "";
+	public static final String CONSTRAINT_IDS_STR = CONSTRAINT_IDS + "";
+	public static final String LINE_IDS_STR = LINE_IDS + "";
+	public static final String THICKNESS_STR = THICKNESS + "";
+	public static final String AUTO_WRAP_TO_SAVE_STR = AUTO_WRAP_TO_SAVE + "";
+	public static final String JUSTIFICATION_STR = JUSTIFICATION + "";
+	public static final String MIN_WIDTH_TO_SAVE_STR = MIN_WIDTH_TO_SAVE + "";
+	public static final String WIDTH_TO_SAVE_STR = WIDTH_TO_SAVE + "";
+	public static final String INITIAL_SPACING_STR = INITIAL_SPACING + "";
+	public static final String LETTER_SPACING_STR = LETTER_SPACING + "";
+	public static final String WORD_SPACING_STR = WORD_SPACING + "";
+	public static final String FORMULA_STR = FORMULA + "";
+	public static final String MASK_STR = MASK + "";
+	public static final String SPACING_STR = SPACING + "";
+	public static final String FONT_STR = FONT + "";
+	public static final String FILLED_STR = FILLED + "";
+	public static final String DOT_TYPE_STR = DOT_TYPE + "";
+	public static final String ARROW_STR = ARROW + "";
+	public static final String LINE_PATTERN_STR = LINE_PATTERN + "";
+	public static final String LINK_TEMPLATE_STR = LINK_TEMPLATE + "";
+	public static final String LINK_FRAMESET_STR = LINK_FRAMESET + "";
+	public static final String LINK_MARK_STR = LINK_MARK + "";
+	public static final String OWNER_STR = OWNER + "";
+	public static final String FILL_PATTERN_STR = FILL_PATTERN + "";
+	public static final String ANCHOR_BOTTOM_STR = ANCHOR_BOTTOM + "";
+	public static final String ANCHOR_TOP_STR = ANCHOR_TOP + "";
+	public static final String ANCHOR_RIGHT_STR = ANCHOR_RIGHT + "";
+	public static final String ANCHOR_LEFT_STR = ANCHOR_LEFT + "";
+	public static final String GRADIENT_ANGLE_STR = GRADIENT_ANGLE + "";
+	public static final String GRADIENT_COLOR_STR = GRADIENT_COLOR + "";
+	public static final String FILL_COLOR_STR = FILL_COLOR + "";
+	public static final String HIGHLIGHT_STR = HIGHLIGHT + "";
+	public static final String DATA_STR = DATA + "";
+	public static final String ACTION_LEAVE_FRAME_STR = ACTION_LEAVE_FRAME + "";
+	public static final String ACTION_ENTER_FRAME_STR = ACTION_ENTER_FRAME + "";
+	public static final String ACTION_CURSOR_LEAVE_STR = ACTION_CURSOR_LEAVE + "";
+	public static final String ACTION_CURSOR_ENTER_STR = ACTION_CURSOR_ENTER + "";
+	public static final String ACTION_MARK_STR = ACTION_MARK + "";
+	public static final String ACTION_STR = ACTION + "";
+	public static final String LINK_STR = LINK + "";
+	public static final String TEXT_STR = TEXT + "";
+	public static final String POSITION_STR = POSITION + "";
+	public static final String BORDER_COLOR_STR = BORDER_COLOR + "";
+	public static final String BACKGROUND_COLOR_STR = BACKGROUND_COLOR + "";
+	public static final String COLOR_STR = COLOR + "";
+	public static final String DATE_CREATED_STR = DATE_CREATED + "";
+	public static final String TYPE_AND_ID_STR = TYPE_AND_ID + "";
 
 	protected String _filename = null;
@@ -113,19 +166,11 @@
 
 	// keep track of methods that are put on the same line
-	private static LinkedHashMap<Character, Method> _ItemTags = null;
+	private static LinkedHashMap<Character, Method> _ItemTags = new LinkedHashMap<Character, Method>();
 	// IMPORTANT: keys in _ItemTagsExt must start with underscore as their first character 
-	private static LinkedHashMap<String, Method> _ItemTagsExt = null;
-
-	protected static LinkedHashMap<Character, Method> _FrameTags = null;
-
-	public DefaultFrameWriter() {
-		
-		if (_ItemTags != null && _FrameTags != null)
-			return;
-
-		_ItemTags = new LinkedHashMap<Character, Method>();
-		_ItemTagsExt = new LinkedHashMap<String, Method>();
-		_FrameTags = new LinkedHashMap<Character, Method>();
-
+	private static LinkedHashMap<String, Method> _ItemTagsExt = new LinkedHashMap<String, Method>();
+
+	protected static LinkedHashMap<Character, Method> _FrameTags = new LinkedHashMap<Character, Method>();
+	
+	{
 		try {
 			_FrameTags.put('V', Frame.class.getMethod("getVersion"));
@@ -213,12 +258,17 @@
 			_ItemTags.put(DefaultFrameWriter.MAGNETIZED_ITEM_BOTTOM, Item.class.getMethod("getMagnetizedItemBottom"));
 			
-			_ItemTagsExt.put(DefaultFrameWriter.ENCRYPTION_LABEL, Item.class.getMethod("getEncryptionLabel"));
-			
-			_ItemTagsExt.put(DefaultFrameWriter.PLACEHOLDER, Text.class.getMethod("getPlaceholder"));
-			_ItemTagsExt.put(DefaultFrameWriter.SINGLE_LINE_ONLY, Text.class.getMethod("isSingleLineOnly"));
-			_ItemTagsExt.put(DefaultFrameWriter.TAB_INDEX, Text.class.getMethod("getTabIndex"));
+			_ItemTagsExt.put(DefaultFrameWriter.ENCRYPTION_LABEL_STR, Item.class.getMethod("getEncryptionLabel"));
+			
+			_ItemTagsExt.put(DefaultFrameWriter.PLACEHOLDER_STR, Text.class.getMethod("getPlaceholder"));
+			_ItemTagsExt.put(DefaultFrameWriter.SINGLE_LINE_ONLY_STR, Text.class.getMethod("isSingleLineOnly"));
+			_ItemTagsExt.put(DefaultFrameWriter.TAB_INDEX_STR, Text.class.getMethod("getTabIndex"));
 		} catch (Exception e) {
 			e.printStackTrace();
 		}
+	}
+
+	public DefaultFrameWriter() {
+		
+
 	}
 
